/* valaproperty.c generated by valac, the Vala compiler
 * generated from valaproperty.vala, do not modify */

/* valaproperty.vala
 *
 * Copyright (C) 2006-2012  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 *	Raffaele Sandrini <raffaele@sandrini.ch>
 */


#include <glib.h>
#include <glib-object.h>
#include "vala.h"
#include <stdlib.h>
#include <string.h>
#include <valagee.h>

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ValaPropertyPrivate {
	ValaParameter* _this_parameter;
	gboolean _interface_only;
	gboolean _is_abstract;
	gboolean _is_virtual;
	gboolean _overrides;
	ValaMemberBinding _binding;
	gboolean _lock_used;
	ValaExpression* _initializer;
	ValaDataType* _data_type;
	ValaProperty* _base_property;
	ValaProperty* _base_interface_property;
	gboolean base_properties_valid;
	ValaPropertyAccessor* _get_accessor;
	ValaPropertyAccessor* _set_accessor;
	gchar* _nick;
	gchar* _blurb;
	gboolean* _notify;
	ValaField* _field;
	gboolean _field_checked;
};


static gint ValaProperty_private_offset;
static gpointer vala_property_parent_class = NULL;
static ValaLockableIface * vala_property_vala_lockable_parent_iface = NULL;

static void vala_property_real_accept (ValaCodeNode* base,
                                ValaCodeVisitor* visitor);
static void vala_property_real_accept_children (ValaCodeNode* base,
                                         ValaCodeVisitor* visitor);
static void vala_property_real_replace_type (ValaCodeNode* base,
                                      ValaDataType* old_type,
                                      ValaDataType* new_type);
static void vala_property_real_replace_expression (ValaCodeNode* base,
                                            ValaExpression* old_node,
                                            ValaExpression* new_node);
static void vala_property_find_base_properties (ValaProperty* self);
static void vala_property_find_base_interface_property (ValaProperty* self,
                                                 ValaClass* cl);
static void vala_property_find_base_class_property (ValaProperty* self,
                                             ValaClass* cl);
static gboolean vala_property_real_check (ValaCodeNode* base,
                                   ValaCodeContext* context);
static gboolean* _bool_dup (gboolean* self);
static void vala_property_finalize (ValaCodeNode * obj);


static inline gpointer
vala_property_get_instance_private (ValaProperty* self)
{
	return G_STRUCT_MEMBER_P (self, ValaProperty_private_offset);
}


/**
 * Creates a new property.
 *
 * @param name              property name
 * @param property_type     property type
 * @param get_accessor      get accessor
 * @param set_accessor      set/construct accessor
 * @param source_reference  reference to source code
 * @return                  newly created property
 */
ValaProperty*
vala_property_construct (GType object_type,
                         const gchar* name,
                         ValaDataType* property_type,
                         ValaPropertyAccessor* get_accessor,
                         ValaPropertyAccessor* set_accessor,
                         ValaSourceReference* source_reference,
                         ValaComment* comment)
{
	ValaProperty* self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValaProperty*) vala_symbol_construct (object_type, name, source_reference, comment);
	vala_property_set_property_type (self, property_type);
	vala_property_set_get_accessor (self, get_accessor);
	vala_property_set_set_accessor (self, set_accessor);
	return self;
}


ValaProperty*
vala_property_new (const gchar* name,
                   ValaDataType* property_type,
                   ValaPropertyAccessor* get_accessor,
                   ValaPropertyAccessor* set_accessor,
                   ValaSourceReference* source_reference,
                   ValaComment* comment)
{
	return vala_property_construct (VALA_TYPE_PROPERTY, name, property_type, get_accessor, set_accessor, source_reference, comment);
}


static void
vala_property_real_accept (ValaCodeNode* base,
                           ValaCodeVisitor* visitor)
{
	ValaProperty * self;
	self = (ValaProperty*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_property (visitor, self);
}


static void
vala_property_real_accept_children (ValaCodeNode* base,
                                    ValaCodeVisitor* visitor)
{
	ValaProperty * self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	ValaPropertyAccessor* _tmp2_;
	ValaPropertyAccessor* _tmp3_;
	ValaPropertyAccessor* _tmp6_;
	ValaPropertyAccessor* _tmp7_;
	ValaExpression* _tmp10_;
	ValaExpression* _tmp11_;
	self = (ValaProperty*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = vala_property_get_property_type (self);
	_tmp1_ = _tmp0_;
	vala_code_node_accept ((ValaCodeNode*) _tmp1_, visitor);
	_tmp2_ = vala_property_get_get_accessor (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		ValaPropertyAccessor* _tmp4_;
		ValaPropertyAccessor* _tmp5_;
		_tmp4_ = vala_property_get_get_accessor (self);
		_tmp5_ = _tmp4_;
		vala_code_node_accept ((ValaCodeNode*) _tmp5_, visitor);
	}
	_tmp6_ = vala_property_get_set_accessor (self);
	_tmp7_ = _tmp6_;
	if (_tmp7_ != NULL) {
		ValaPropertyAccessor* _tmp8_;
		ValaPropertyAccessor* _tmp9_;
		_tmp8_ = vala_property_get_set_accessor (self);
		_tmp9_ = _tmp8_;
		vala_code_node_accept ((ValaCodeNode*) _tmp9_, visitor);
	}
	_tmp10_ = vala_property_get_initializer (self);
	_tmp11_ = _tmp10_;
	if (_tmp11_ != NULL) {
		ValaExpression* _tmp12_;
		ValaExpression* _tmp13_;
		_tmp12_ = vala_property_get_initializer (self);
		_tmp13_ = _tmp12_;
		vala_code_node_accept ((ValaCodeNode*) _tmp13_, visitor);
	}
}


/**
 * Checks whether the accessors of this property are compatible
 * with the specified base property.
 *
 * @param base_property a property
 * @param invalid_match error string about which check failed
 * @return true if the specified property is compatible to this property
 */
gboolean
vala_property_compatible (ValaProperty* self,
                          ValaProperty* base_property,
                          gchar* * invalid_match)
{
	gchar* _vala_invalid_match = NULL;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ValaPropertyAccessor* _tmp2_;
	ValaPropertyAccessor* _tmp3_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	ValaPropertyAccessor* _tmp14_;
	ValaPropertyAccessor* _tmp15_;
	ValaDataType* object_type = NULL;
	ValaSymbol* _tmp24_;
	ValaSymbol* _tmp25_;
	ValaDataType* _tmp26_;
	ValaPropertyAccessor* _tmp27_;
	ValaPropertyAccessor* _tmp28_;
	ValaPropertyAccessor* _tmp41_;
	ValaPropertyAccessor* _tmp42_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (base_property != NULL, FALSE);
	_tmp2_ = vala_property_get_get_accessor (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		ValaPropertyAccessor* _tmp4_;
		ValaPropertyAccessor* _tmp5_;
		_tmp4_ = vala_property_get_get_accessor (base_property);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_ != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp6_ = FALSE;
		ValaPropertyAccessor* _tmp7_;
		ValaPropertyAccessor* _tmp8_;
		_tmp7_ = vala_property_get_get_accessor (self);
		_tmp8_ = _tmp7_;
		if (_tmp8_ != NULL) {
			ValaPropertyAccessor* _tmp9_;
			ValaPropertyAccessor* _tmp10_;
			_tmp9_ = vala_property_get_get_accessor (base_property);
			_tmp10_ = _tmp9_;
			_tmp6_ = _tmp10_ == NULL;
		} else {
			_tmp6_ = FALSE;
		}
		_tmp0_ = _tmp6_;
	}
	if (_tmp0_) {
		gchar* _tmp11_;
		_tmp11_ = g_strdup ("incompatible get accessor");
		_g_free0 (_vala_invalid_match);
		_vala_invalid_match = _tmp11_;
		result = FALSE;
		if (invalid_match) {
			*invalid_match = _vala_invalid_match;
		} else {
			_g_free0 (_vala_invalid_match);
		}
		return result;
	}
	_tmp14_ = vala_property_get_set_accessor (self);
	_tmp15_ = _tmp14_;
	if (_tmp15_ == NULL) {
		ValaPropertyAccessor* _tmp16_;
		ValaPropertyAccessor* _tmp17_;
		_tmp16_ = vala_property_get_set_accessor (base_property);
		_tmp17_ = _tmp16_;
		_tmp13_ = _tmp17_ != NULL;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		_tmp12_ = TRUE;
	} else {
		gboolean _tmp18_ = FALSE;
		ValaPropertyAccessor* _tmp19_;
		ValaPropertyAccessor* _tmp20_;
		_tmp19_ = vala_property_get_set_accessor (self);
		_tmp20_ = _tmp19_;
		if (_tmp20_ != NULL) {
			ValaPropertyAccessor* _tmp21_;
			ValaPropertyAccessor* _tmp22_;
			_tmp21_ = vala_property_get_set_accessor (base_property);
			_tmp22_ = _tmp21_;
			_tmp18_ = _tmp22_ == NULL;
		} else {
			_tmp18_ = FALSE;
		}
		_tmp12_ = _tmp18_;
	}
	if (_tmp12_) {
		gchar* _tmp23_;
		_tmp23_ = g_strdup ("incompatible set accessor");
		_g_free0 (_vala_invalid_match);
		_vala_invalid_match = _tmp23_;
		result = FALSE;
		if (invalid_match) {
			*invalid_match = _vala_invalid_match;
		} else {
			_g_free0 (_vala_invalid_match);
		}
		return result;
	}
	_tmp24_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp25_ = _tmp24_;
	_tmp26_ = vala_semantic_analyzer_get_data_type_for_symbol (_tmp25_);
	object_type = _tmp26_;
	_tmp27_ = vala_property_get_get_accessor (self);
	_tmp28_ = _tmp27_;
	if (_tmp28_ != NULL) {
		ValaDataType* actual_base_type = NULL;
		ValaPropertyAccessor* _tmp29_;
		ValaPropertyAccessor* _tmp30_;
		ValaDataType* _tmp31_;
		ValaDataType* _tmp32_;
		ValaDataType* _tmp33_;
		ValaDataType* _tmp34_;
		ValaDataType* _tmp35_;
		ValaPropertyAccessor* _tmp36_;
		ValaPropertyAccessor* _tmp37_;
		ValaDataType* _tmp38_;
		ValaDataType* _tmp39_;
		_tmp29_ = vala_property_get_get_accessor (base_property);
		_tmp30_ = _tmp29_;
		_tmp31_ = vala_property_accessor_get_value_type (_tmp30_);
		_tmp32_ = _tmp31_;
		_tmp33_ = object_type;
		_tmp34_ = vala_data_type_get_actual_type (_tmp32_, _tmp33_, NULL, (ValaCodeNode*) self);
		actual_base_type = _tmp34_;
		_tmp35_ = actual_base_type;
		_tmp36_ = vala_property_get_get_accessor (self);
		_tmp37_ = _tmp36_;
		_tmp38_ = vala_property_accessor_get_value_type (_tmp37_);
		_tmp39_ = _tmp38_;
		if (!vala_data_type_equals (_tmp35_, _tmp39_)) {
			gchar* _tmp40_;
			_tmp40_ = g_strdup ("incompatible get accessor type");
			_g_free0 (_vala_invalid_match);
			_vala_invalid_match = _tmp40_;
			result = FALSE;
			_vala_code_node_unref0 (actual_base_type);
			_vala_code_node_unref0 (object_type);
			if (invalid_match) {
				*invalid_match = _vala_invalid_match;
			} else {
				_g_free0 (_vala_invalid_match);
			}
			return result;
		}
		_vala_code_node_unref0 (actual_base_type);
	}
	_tmp41_ = vala_property_get_set_accessor (self);
	_tmp42_ = _tmp41_;
	if (_tmp42_ != NULL) {
		ValaDataType* actual_base_type = NULL;
		ValaPropertyAccessor* _tmp43_;
		ValaPropertyAccessor* _tmp44_;
		ValaDataType* _tmp45_;
		ValaDataType* _tmp46_;
		ValaDataType* _tmp47_;
		ValaDataType* _tmp48_;
		ValaDataType* _tmp49_;
		ValaPropertyAccessor* _tmp50_;
		ValaPropertyAccessor* _tmp51_;
		ValaDataType* _tmp52_;
		ValaDataType* _tmp53_;
		ValaPropertyAccessor* _tmp55_;
		ValaPropertyAccessor* _tmp56_;
		gboolean _tmp57_;
		gboolean _tmp58_;
		ValaPropertyAccessor* _tmp59_;
		ValaPropertyAccessor* _tmp60_;
		gboolean _tmp61_;
		gboolean _tmp62_;
		ValaPropertyAccessor* _tmp64_;
		ValaPropertyAccessor* _tmp65_;
		gboolean _tmp66_;
		gboolean _tmp67_;
		ValaPropertyAccessor* _tmp68_;
		ValaPropertyAccessor* _tmp69_;
		gboolean _tmp70_;
		gboolean _tmp71_;
		_tmp43_ = vala_property_get_set_accessor (base_property);
		_tmp44_ = _tmp43_;
		_tmp45_ = vala_property_accessor_get_value_type (_tmp44_);
		_tmp46_ = _tmp45_;
		_tmp47_ = object_type;
		_tmp48_ = vala_data_type_get_actual_type (_tmp46_, _tmp47_, NULL, (ValaCodeNode*) self);
		actual_base_type = _tmp48_;
		_tmp49_ = actual_base_type;
		_tmp50_ = vala_property_get_set_accessor (self);
		_tmp51_ = _tmp50_;
		_tmp52_ = vala_property_accessor_get_value_type (_tmp51_);
		_tmp53_ = _tmp52_;
		if (!vala_data_type_equals (_tmp49_, _tmp53_)) {
			gchar* _tmp54_;
			_tmp54_ = g_strdup ("incompatible set accessor type");
			_g_free0 (_vala_invalid_match);
			_vala_invalid_match = _tmp54_;
			result = FALSE;
			_vala_code_node_unref0 (actual_base_type);
			_vala_code_node_unref0 (object_type);
			if (invalid_match) {
				*invalid_match = _vala_invalid_match;
			} else {
				_g_free0 (_vala_invalid_match);
			}
			return result;
		}
		_tmp55_ = vala_property_get_set_accessor (self);
		_tmp56_ = _tmp55_;
		_tmp57_ = vala_property_accessor_get_writable (_tmp56_);
		_tmp58_ = _tmp57_;
		_tmp59_ = vala_property_get_set_accessor (base_property);
		_tmp60_ = _tmp59_;
		_tmp61_ = vala_property_accessor_get_writable (_tmp60_);
		_tmp62_ = _tmp61_;
		if (_tmp58_ != _tmp62_) {
			gchar* _tmp63_;
			_tmp63_ = g_strdup ("incompatible set accessor");
			_g_free0 (_vala_invalid_match);
			_vala_invalid_match = _tmp63_;
			result = FALSE;
			_vala_code_node_unref0 (actual_base_type);
			_vala_code_node_unref0 (object_type);
			if (invalid_match) {
				*invalid_match = _vala_invalid_match;
			} else {
				_g_free0 (_vala_invalid_match);
			}
			return result;
		}
		_tmp64_ = vala_property_get_set_accessor (self);
		_tmp65_ = _tmp64_;
		_tmp66_ = vala_property_accessor_get_construction (_tmp65_);
		_tmp67_ = _tmp66_;
		_tmp68_ = vala_property_get_set_accessor (base_property);
		_tmp69_ = _tmp68_;
		_tmp70_ = vala_property_accessor_get_construction (_tmp69_);
		_tmp71_ = _tmp70_;
		if (_tmp67_ != _tmp71_) {
			gchar* _tmp72_;
			_tmp72_ = g_strdup ("incompatible set accessor");
			_g_free0 (_vala_invalid_match);
			_vala_invalid_match = _tmp72_;
			result = FALSE;
			_vala_code_node_unref0 (actual_base_type);
			_vala_code_node_unref0 (object_type);
			if (invalid_match) {
				*invalid_match = _vala_invalid_match;
			} else {
				_g_free0 (_vala_invalid_match);
			}
			return result;
		}
		_vala_code_node_unref0 (actual_base_type);
	}
	_g_free0 (_vala_invalid_match);
	_vala_invalid_match = NULL;
	result = TRUE;
	_vala_code_node_unref0 (object_type);
	if (invalid_match) {
		*invalid_match = _vala_invalid_match;
	} else {
		_g_free0 (_vala_invalid_match);
	}
	return result;
}


static void
vala_property_real_replace_type (ValaCodeNode* base,
                                 ValaDataType* old_type,
                                 ValaDataType* new_type)
{
	ValaProperty * self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	self = (ValaProperty*) base;
	g_return_if_fail (old_type != NULL);
	g_return_if_fail (new_type != NULL);
	_tmp0_ = vala_property_get_property_type (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_type) {
		vala_property_set_property_type (self, new_type);
	}
}


static void
vala_property_real_replace_expression (ValaCodeNode* base,
                                       ValaExpression* old_node,
                                       ValaExpression* new_node)
{
	ValaProperty * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	self = (ValaProperty*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	_tmp0_ = vala_property_get_initializer (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_node) {
		vala_property_set_initializer (self, new_node);
	}
}


static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}


static void
vala_property_find_base_properties (ValaProperty* self)
{
	gboolean _tmp0_;
	ValaSymbol* _tmp1_;
	ValaSymbol* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->base_properties_valid;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp2_ = _tmp1_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, VALA_TYPE_CLASS)) {
		ValaSymbol* _tmp3_;
		ValaSymbol* _tmp4_;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		_tmp3_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp4_ = _tmp3_;
		vala_property_find_base_interface_property (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, VALA_TYPE_CLASS, ValaClass));
		_tmp6_ = self->priv->_is_virtual;
		if (_tmp6_) {
			_tmp5_ = TRUE;
		} else {
			gboolean _tmp7_;
			_tmp7_ = self->priv->_overrides;
			_tmp5_ = _tmp7_;
		}
		if (_tmp5_) {
			ValaSymbol* _tmp8_;
			ValaSymbol* _tmp9_;
			_tmp8_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp9_ = _tmp8_;
			vala_property_find_base_class_property (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, VALA_TYPE_CLASS, ValaClass));
		}
	} else {
		ValaSymbol* _tmp10_;
		ValaSymbol* _tmp11_;
		_tmp10_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp11_ = _tmp10_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, VALA_TYPE_INTERFACE)) {
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_;
			_tmp13_ = self->priv->_is_virtual;
			if (_tmp13_) {
				_tmp12_ = TRUE;
			} else {
				gboolean _tmp14_;
				_tmp14_ = self->priv->_is_abstract;
				_tmp12_ = _tmp14_;
			}
			if (_tmp12_) {
				ValaProperty* _tmp15_;
				_tmp15_ = _vala_code_node_ref0 (self);
				_vala_code_node_unref0 (self->priv->_base_interface_property);
				self->priv->_base_interface_property = _tmp15_;
			}
		}
	}
	self->priv->base_properties_valid = TRUE;
}


static void
vala_property_find_base_class_property (ValaProperty* self,
                                        ValaClass* cl)
{
	ValaSymbol* sym = NULL;
	ValaScope* _tmp0_;
	ValaScope* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	ValaSymbol* _tmp4_;
	ValaSymbol* _tmp5_;
	ValaClass* _tmp27_;
	ValaClass* _tmp28_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cl != NULL);
	_tmp0_ = vala_symbol_get_scope ((ValaSymbol*) cl);
	_tmp1_ = _tmp0_;
	_tmp2_ = vala_symbol_get_name ((ValaSymbol*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = vala_scope_lookup (_tmp1_, _tmp3_);
	sym = _tmp4_;
	_tmp5_ = sym;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, VALA_TYPE_PROPERTY)) {
		ValaProperty* base_property = NULL;
		ValaSymbol* _tmp6_;
		ValaProperty* _tmp7_;
		gboolean _tmp8_ = FALSE;
		ValaProperty* _tmp9_;
		gboolean _tmp10_;
		_tmp6_ = sym;
		_tmp7_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, VALA_TYPE_PROPERTY, ValaProperty));
		base_property = _tmp7_;
		_tmp9_ = base_property;
		_tmp10_ = _tmp9_->priv->_is_abstract;
		if (_tmp10_) {
			_tmp8_ = TRUE;
		} else {
			ValaProperty* _tmp11_;
			gboolean _tmp12_;
			_tmp11_ = base_property;
			_tmp12_ = _tmp11_->priv->_is_virtual;
			_tmp8_ = _tmp12_;
		}
		if (_tmp8_) {
			gchar* invalid_match = NULL;
			ValaProperty* _tmp13_;
			gchar* _tmp14_ = NULL;
			gboolean _tmp15_;
			ValaProperty* _tmp26_;
			_tmp13_ = base_property;
			_tmp15_ = vala_property_compatible (self, _tmp13_, &_tmp14_);
			_g_free0 (invalid_match);
			invalid_match = _tmp14_;
			if (!_tmp15_) {
				ValaSourceReference* _tmp16_;
				ValaSourceReference* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				ValaProperty* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp16_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp17_ = _tmp16_;
				_tmp18_ = vala_symbol_get_full_name ((ValaSymbol*) self);
				_tmp19_ = _tmp18_;
				_tmp20_ = base_property;
				_tmp21_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp20_);
				_tmp22_ = _tmp21_;
				_tmp23_ = invalid_match;
				_tmp24_ = g_strdup_printf ("Type and/or accessors of overriding property `%s' do not match overrid" \
"den property `%s': %s.", _tmp19_, _tmp22_, _tmp23_);
				_tmp25_ = _tmp24_;
				vala_report_error (_tmp17_, _tmp25_);
				_g_free0 (_tmp25_);
				_g_free0 (_tmp22_);
				_g_free0 (_tmp19_);
				_g_free0 (invalid_match);
				_vala_code_node_unref0 (base_property);
				_vala_code_node_unref0 (sym);
				return;
			}
			_tmp26_ = base_property;
			self->priv->_base_property = _tmp26_;
			_g_free0 (invalid_match);
			_vala_code_node_unref0 (base_property);
			_vala_code_node_unref0 (sym);
			return;
		}
		_vala_code_node_unref0 (base_property);
	}
	_tmp27_ = vala_class_get_base_class (cl);
	_tmp28_ = _tmp27_;
	if (_tmp28_ != NULL) {
		ValaClass* _tmp29_;
		ValaClass* _tmp30_;
		_tmp29_ = vala_class_get_base_class (cl);
		_tmp30_ = _tmp29_;
		vala_property_find_base_class_property (self, _tmp30_);
	}
	_vala_code_node_unref0 (sym);
}


static void
vala_property_find_base_interface_property (ValaProperty* self,
                                            ValaClass* cl)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (cl != NULL);
	{
		ValaList* _type_list = NULL;
		ValaList* _tmp0_;
		gint _type_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _type_index = 0;
		_tmp0_ = vala_class_get_base_types (cl);
		_type_list = _tmp0_;
		_tmp1_ = _type_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_type_size = _tmp3_;
		_type_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			ValaDataType* type = NULL;
			ValaList* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_;
			ValaDataType* _tmp10_;
			ValaTypeSymbol* _tmp11_;
			ValaTypeSymbol* _tmp12_;
			_tmp4_ = _type_index;
			_type_index = _tmp4_ + 1;
			_tmp5_ = _type_index;
			_tmp6_ = _type_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _type_list;
			_tmp8_ = _type_index;
			_tmp9_ = vala_list_get (_tmp7_, _tmp8_);
			type = (ValaDataType*) _tmp9_;
			_tmp10_ = type;
			_tmp11_ = vala_data_type_get_data_type (_tmp10_);
			_tmp12_ = _tmp11_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, VALA_TYPE_INTERFACE)) {
				ValaSymbol* sym = NULL;
				ValaDataType* _tmp13_;
				ValaTypeSymbol* _tmp14_;
				ValaTypeSymbol* _tmp15_;
				ValaScope* _tmp16_;
				ValaScope* _tmp17_;
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				ValaSymbol* _tmp20_;
				ValaSymbol* _tmp21_;
				_tmp13_ = type;
				_tmp14_ = vala_data_type_get_data_type (_tmp13_);
				_tmp15_ = _tmp14_;
				_tmp16_ = vala_symbol_get_scope ((ValaSymbol*) _tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = vala_symbol_get_name ((ValaSymbol*) self);
				_tmp19_ = _tmp18_;
				_tmp20_ = vala_scope_lookup (_tmp17_, _tmp19_);
				sym = _tmp20_;
				_tmp21_ = sym;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, VALA_TYPE_PROPERTY)) {
					ValaProperty* base_property = NULL;
					ValaSymbol* _tmp22_;
					ValaProperty* _tmp23_;
					gboolean _tmp24_ = FALSE;
					ValaProperty* _tmp25_;
					gboolean _tmp26_;
					_tmp22_ = sym;
					_tmp23_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, VALA_TYPE_PROPERTY, ValaProperty));
					base_property = _tmp23_;
					_tmp25_ = base_property;
					_tmp26_ = _tmp25_->priv->_is_abstract;
					if (_tmp26_) {
						_tmp24_ = TRUE;
					} else {
						ValaProperty* _tmp27_;
						gboolean _tmp28_;
						_tmp27_ = base_property;
						_tmp28_ = _tmp27_->priv->_is_virtual;
						_tmp24_ = _tmp28_;
					}
					if (_tmp24_) {
						gchar* invalid_match = NULL;
						ValaProperty* _tmp29_;
						gchar* _tmp30_ = NULL;
						gboolean _tmp31_;
						ValaProperty* _tmp42_;
						ValaProperty* _tmp43_;
						_tmp29_ = base_property;
						_tmp31_ = vala_property_compatible (self, _tmp29_, &_tmp30_);
						_g_free0 (invalid_match);
						invalid_match = _tmp30_;
						if (!_tmp31_) {
							ValaSourceReference* _tmp32_;
							ValaSourceReference* _tmp33_;
							gchar* _tmp34_;
							gchar* _tmp35_;
							ValaProperty* _tmp36_;
							gchar* _tmp37_;
							gchar* _tmp38_;
							const gchar* _tmp39_;
							gchar* _tmp40_;
							gchar* _tmp41_;
							vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
							_tmp32_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
							_tmp33_ = _tmp32_;
							_tmp34_ = vala_symbol_get_full_name ((ValaSymbol*) self);
							_tmp35_ = _tmp34_;
							_tmp36_ = base_property;
							_tmp37_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp36_);
							_tmp38_ = _tmp37_;
							_tmp39_ = invalid_match;
							_tmp40_ = g_strdup_printf ("Type and/or accessors of overriding property `%s' do not match overrid" \
"den property `%s': %s.", _tmp35_, _tmp38_, _tmp39_);
							_tmp41_ = _tmp40_;
							vala_report_error (_tmp33_, _tmp41_);
							_g_free0 (_tmp41_);
							_g_free0 (_tmp38_);
							_g_free0 (_tmp35_);
							_g_free0 (invalid_match);
							_vala_code_node_unref0 (base_property);
							_vala_code_node_unref0 (sym);
							_vala_code_node_unref0 (type);
							_vala_iterable_unref0 (_type_list);
							return;
						}
						_tmp42_ = base_property;
						_tmp43_ = _vala_code_node_ref0 (_tmp42_);
						_vala_code_node_unref0 (self->priv->_base_interface_property);
						self->priv->_base_interface_property = _tmp43_;
						_g_free0 (invalid_match);
						_vala_code_node_unref0 (base_property);
						_vala_code_node_unref0 (sym);
						_vala_code_node_unref0 (type);
						_vala_iterable_unref0 (_type_list);
						return;
					}
					_vala_code_node_unref0 (base_property);
				}
				_vala_code_node_unref0 (sym);
			}
			_vala_code_node_unref0 (type);
		}
		_vala_iterable_unref0 (_type_list);
	}
}


static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}


static gboolean
vala_property_real_check (ValaCodeNode* base,
                          ValaCodeContext* context)
{
	ValaProperty * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp4_ = FALSE;
	ValaSymbol* _tmp5_;
	ValaSymbol* _tmp6_;
	gboolean _tmp22_;
	ValaSourceFile* old_source_file = NULL;
	ValaSemanticAnalyzer* _tmp59_;
	ValaSemanticAnalyzer* _tmp60_;
	ValaSourceFile* _tmp61_;
	ValaSourceFile* _tmp62_;
	ValaSourceFile* _tmp63_;
	ValaSymbol* old_symbol = NULL;
	ValaSemanticAnalyzer* _tmp64_;
	ValaSemanticAnalyzer* _tmp65_;
	ValaSymbol* _tmp66_;
	ValaSymbol* _tmp67_;
	ValaSymbol* _tmp68_;
	ValaSourceReference* _tmp69_;
	ValaSourceReference* _tmp70_;
	ValaSemanticAnalyzer* _tmp77_;
	ValaSemanticAnalyzer* _tmp78_;
	ValaDataType* _tmp79_;
	ValaDataType* _tmp80_;
	ValaDataType* _tmp83_;
	ValaDataType* _tmp84_;
	gboolean _tmp85_ = FALSE;
	ValaPropertyAccessor* _tmp86_;
	ValaPropertyAccessor* _tmp87_;
	ValaPropertyAccessor* _tmp96_;
	ValaPropertyAccessor* _tmp97_;
	ValaPropertyAccessor* _tmp100_;
	ValaPropertyAccessor* _tmp101_;
	gboolean _tmp104_ = FALSE;
	gboolean _tmp105_ = FALSE;
	ValaExpression* _tmp106_;
	ValaExpression* _tmp107_;
	ValaExpression* _tmp117_;
	ValaExpression* _tmp118_;
	ValaSemanticAnalyzer* _tmp121_;
	ValaSemanticAnalyzer* _tmp122_;
	ValaDataType* _tmp123_;
	ValaDataType* _tmp124_;
	gboolean _tmp135_ = FALSE;
	gboolean _tmp136_;
	gboolean _tmp145_ = FALSE;
	gboolean _tmp146_ = FALSE;
	gboolean _tmp147_ = FALSE;
	gboolean _tmp148_;
	gboolean _tmp149_;
	gboolean _tmp165_ = FALSE;
	ValaPropertyAccessor* _tmp166_;
	ValaPropertyAccessor* _tmp167_;
	gboolean _tmp180_ = FALSE;
	gboolean _tmp181_ = FALSE;
	gboolean _tmp182_ = FALSE;
	ValaExpression* _tmp183_;
	ValaExpression* _tmp184_;
	ValaSemanticAnalyzer* _tmp215_;
	ValaSemanticAnalyzer* _tmp216_;
	ValaSourceFile* _tmp217_;
	ValaSemanticAnalyzer* _tmp218_;
	ValaSemanticAnalyzer* _tmp219_;
	ValaSymbol* _tmp220_;
	gboolean _tmp221_;
	gboolean _tmp222_;
	self = (ValaProperty*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp5_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp6_ = _tmp5_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, VALA_TYPE_CLASS)) {
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_;
		_tmp8_ = self->priv->_is_abstract;
		if (_tmp8_) {
			_tmp7_ = TRUE;
		} else {
			gboolean _tmp9_;
			_tmp9_ = self->priv->_is_virtual;
			_tmp7_ = _tmp9_;
		}
		_tmp4_ = _tmp7_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		ValaClass* cl = NULL;
		ValaSymbol* _tmp10_;
		ValaSymbol* _tmp11_;
		ValaClass* _tmp12_;
		gboolean _tmp13_ = FALSE;
		ValaClass* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
		_tmp10_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp11_ = _tmp10_;
		_tmp12_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, VALA_TYPE_CLASS, ValaClass));
		cl = _tmp12_;
		_tmp14_ = cl;
		_tmp15_ = vala_class_get_is_compact (_tmp14_);
		_tmp16_ = _tmp15_;
		if (_tmp16_) {
			ValaClass* _tmp17_;
			ValaClass* _tmp18_;
			ValaClass* _tmp19_;
			_tmp17_ = cl;
			_tmp18_ = vala_class_get_base_class (_tmp17_);
			_tmp19_ = _tmp18_;
			_tmp13_ = _tmp19_ != NULL;
		} else {
			_tmp13_ = FALSE;
		}
		if (_tmp13_) {
			ValaSourceReference* _tmp20_;
			ValaSourceReference* _tmp21_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp20_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp21_ = _tmp20_;
			vala_report_error (_tmp21_, "Abstract and virtual properties may not be declared in derived compact" \
" classes");
			result = FALSE;
			_vala_code_node_unref0 (cl);
			return result;
		}
		_vala_code_node_unref0 (cl);
	}
	_tmp22_ = self->priv->_is_abstract;
	if (_tmp22_) {
		ValaSymbol* _tmp23_;
		ValaSymbol* _tmp24_;
		_tmp23_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp24_ = _tmp23_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp24_, VALA_TYPE_CLASS)) {
			ValaClass* cl = NULL;
			ValaSymbol* _tmp25_;
			ValaSymbol* _tmp26_;
			ValaClass* _tmp27_;
			ValaClass* _tmp28_;
			gboolean _tmp29_;
			gboolean _tmp30_;
			_tmp25_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp26_ = _tmp25_;
			_tmp27_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, VALA_TYPE_CLASS, ValaClass));
			cl = _tmp27_;
			_tmp28_ = cl;
			_tmp29_ = vala_class_get_is_abstract (_tmp28_);
			_tmp30_ = _tmp29_;
			if (!_tmp30_) {
				ValaSourceReference* _tmp31_;
				ValaSourceReference* _tmp32_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp31_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp32_ = _tmp31_;
				vala_report_error (_tmp32_, "Abstract properties may not be declared in non-abstract classes");
				result = FALSE;
				_vala_code_node_unref0 (cl);
				return result;
			}
			_vala_code_node_unref0 (cl);
		} else {
			ValaSymbol* _tmp33_;
			ValaSymbol* _tmp34_;
			_tmp33_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp34_ = _tmp33_;
			if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp34_, VALA_TYPE_INTERFACE)) {
				ValaSourceReference* _tmp35_;
				ValaSourceReference* _tmp36_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp35_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp36_ = _tmp35_;
				vala_report_error (_tmp36_, "Abstract properties may not be declared outside of classes and interfa" \
"ces");
				result = FALSE;
				return result;
			}
		}
	} else {
		gboolean _tmp37_;
		_tmp37_ = self->priv->_is_virtual;
		if (_tmp37_) {
			gboolean _tmp38_ = FALSE;
			ValaSymbol* _tmp39_;
			ValaSymbol* _tmp40_;
			_tmp39_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp40_ = _tmp39_;
			if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp40_, VALA_TYPE_CLASS)) {
				ValaSymbol* _tmp41_;
				ValaSymbol* _tmp42_;
				_tmp41_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
				_tmp42_ = _tmp41_;
				_tmp38_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp42_, VALA_TYPE_INTERFACE);
			} else {
				_tmp38_ = FALSE;
			}
			if (_tmp38_) {
				ValaSourceReference* _tmp43_;
				ValaSourceReference* _tmp44_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp43_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp44_ = _tmp43_;
				vala_report_error (_tmp44_, "Virtual properties may not be declared outside of classes and interfac" \
"es");
				result = FALSE;
				return result;
			}
		} else {
			gboolean _tmp45_;
			_tmp45_ = self->priv->_overrides;
			if (_tmp45_) {
				ValaSymbol* _tmp46_;
				ValaSymbol* _tmp47_;
				_tmp46_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
				_tmp47_ = _tmp46_;
				if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp47_, VALA_TYPE_CLASS)) {
					ValaSourceReference* _tmp48_;
					ValaSourceReference* _tmp49_;
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					_tmp48_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp49_ = _tmp48_;
					vala_report_error (_tmp49_, "Properties may not be overridden outside of classes");
					result = FALSE;
					return result;
				}
			} else {
				ValaSymbolAccessibility _tmp50_;
				ValaSymbolAccessibility _tmp51_;
				_tmp50_ = vala_symbol_get_access ((ValaSymbol*) self);
				_tmp51_ = _tmp50_;
				if (_tmp51_ == VALA_SYMBOL_ACCESSIBILITY_PROTECTED) {
					gboolean _tmp52_ = FALSE;
					ValaSymbol* _tmp53_;
					ValaSymbol* _tmp54_;
					_tmp53_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
					_tmp54_ = _tmp53_;
					if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp54_, VALA_TYPE_CLASS)) {
						ValaSymbol* _tmp55_;
						ValaSymbol* _tmp56_;
						_tmp55_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
						_tmp56_ = _tmp55_;
						_tmp52_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp56_, VALA_TYPE_INTERFACE);
					} else {
						_tmp52_ = FALSE;
					}
					if (_tmp52_) {
						ValaSourceReference* _tmp57_;
						ValaSourceReference* _tmp58_;
						vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
						_tmp57_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
						_tmp58_ = _tmp57_;
						vala_report_error (_tmp58_, "Protected properties may not be declared outside of classes and interf" \
"aces");
						result = FALSE;
						return result;
					}
				}
			}
		}
	}
	_tmp59_ = vala_code_context_get_analyzer (context);
	_tmp60_ = _tmp59_;
	_tmp61_ = vala_semantic_analyzer_get_current_source_file (_tmp60_);
	_tmp62_ = _tmp61_;
	_tmp63_ = _vala_source_file_ref0 (_tmp62_);
	old_source_file = _tmp63_;
	_tmp64_ = vala_code_context_get_analyzer (context);
	_tmp65_ = _tmp64_;
	_tmp66_ = vala_semantic_analyzer_get_current_symbol (_tmp65_);
	_tmp67_ = _tmp66_;
	_tmp68_ = _vala_code_node_ref0 (_tmp67_);
	old_symbol = _tmp68_;
	_tmp69_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
	_tmp70_ = _tmp69_;
	if (_tmp70_ != NULL) {
		ValaSemanticAnalyzer* _tmp71_;
		ValaSemanticAnalyzer* _tmp72_;
		ValaSourceReference* _tmp73_;
		ValaSourceReference* _tmp74_;
		ValaSourceFile* _tmp75_;
		ValaSourceFile* _tmp76_;
		_tmp71_ = vala_code_context_get_analyzer (context);
		_tmp72_ = _tmp71_;
		_tmp73_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp74_ = _tmp73_;
		_tmp75_ = vala_source_reference_get_file (_tmp74_);
		_tmp76_ = _tmp75_;
		vala_semantic_analyzer_set_current_source_file (_tmp72_, _tmp76_);
	}
	_tmp77_ = vala_code_context_get_analyzer (context);
	_tmp78_ = _tmp77_;
	vala_semantic_analyzer_set_current_symbol (_tmp78_, (ValaSymbol*) self);
	_tmp79_ = vala_property_get_property_type (self);
	_tmp80_ = _tmp79_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp80_, VALA_TYPE_VOID_TYPE)) {
		ValaSourceReference* _tmp81_;
		ValaSourceReference* _tmp82_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp81_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp82_ = _tmp81_;
		vala_report_error (_tmp82_, "'void' not supported as property type");
		result = FALSE;
		_vala_code_node_unref0 (old_symbol);
		_vala_source_file_unref0 (old_source_file);
		return result;
	}
	_tmp83_ = vala_property_get_property_type (self);
	_tmp84_ = _tmp83_;
	vala_code_node_check ((ValaCodeNode*) _tmp84_, context);
	_tmp86_ = vala_property_get_get_accessor (self);
	_tmp87_ = _tmp86_;
	if (_tmp87_ == NULL) {
		ValaPropertyAccessor* _tmp88_;
		ValaPropertyAccessor* _tmp89_;
		_tmp88_ = vala_property_get_set_accessor (self);
		_tmp89_ = _tmp88_;
		_tmp85_ = _tmp89_ == NULL;
	} else {
		_tmp85_ = FALSE;
	}
	if (_tmp85_) {
		ValaSourceReference* _tmp90_;
		ValaSourceReference* _tmp91_;
		gchar* _tmp92_;
		gchar* _tmp93_;
		gchar* _tmp94_;
		gchar* _tmp95_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp90_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp91_ = _tmp90_;
		_tmp92_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp93_ = _tmp92_;
		_tmp94_ = g_strdup_printf ("Property `%s' must have a `get' accessor and/or a `set' mutator", _tmp93_);
		_tmp95_ = _tmp94_;
		vala_report_error (_tmp91_, _tmp95_);
		_g_free0 (_tmp95_);
		_g_free0 (_tmp93_);
		result = FALSE;
		_vala_code_node_unref0 (old_symbol);
		_vala_source_file_unref0 (old_source_file);
		return result;
	}
	_tmp96_ = vala_property_get_get_accessor (self);
	_tmp97_ = _tmp96_;
	if (_tmp97_ != NULL) {
		ValaPropertyAccessor* _tmp98_;
		ValaPropertyAccessor* _tmp99_;
		_tmp98_ = vala_property_get_get_accessor (self);
		_tmp99_ = _tmp98_;
		vala_code_node_check ((ValaCodeNode*) _tmp99_, context);
	}
	_tmp100_ = vala_property_get_set_accessor (self);
	_tmp101_ = _tmp100_;
	if (_tmp101_ != NULL) {
		ValaPropertyAccessor* _tmp102_;
		ValaPropertyAccessor* _tmp103_;
		_tmp102_ = vala_property_get_set_accessor (self);
		_tmp103_ = _tmp102_;
		vala_code_node_check ((ValaCodeNode*) _tmp103_, context);
	}
	_tmp106_ = vala_property_get_initializer (self);
	_tmp107_ = _tmp106_;
	if (_tmp107_ != NULL) {
		ValaField* _tmp108_;
		ValaField* _tmp109_;
		_tmp108_ = vala_property_get_field (self);
		_tmp109_ = _tmp108_;
		_tmp105_ = _tmp109_ == NULL;
	} else {
		_tmp105_ = FALSE;
	}
	if (_tmp105_) {
		gboolean _tmp110_;
		_tmp110_ = self->priv->_is_abstract;
		_tmp104_ = !_tmp110_;
	} else {
		_tmp104_ = FALSE;
	}
	if (_tmp104_) {
		ValaSourceReference* _tmp111_;
		ValaSourceReference* _tmp112_;
		gchar* _tmp113_;
		gchar* _tmp114_;
		gchar* _tmp115_;
		gchar* _tmp116_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp111_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp112_ = _tmp111_;
		_tmp113_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp114_ = _tmp113_;
		_tmp115_ = g_strdup_printf ("Property `%s' with custom `get' accessor and/or `set' mutator cannot h" \
"ave `default' value", _tmp114_);
		_tmp116_ = _tmp115_;
		vala_report_error (_tmp112_, _tmp116_);
		_g_free0 (_tmp116_);
		_g_free0 (_tmp114_);
		result = FALSE;
		_vala_code_node_unref0 (old_symbol);
		_vala_source_file_unref0 (old_source_file);
		return result;
	}
	_tmp117_ = vala_property_get_initializer (self);
	_tmp118_ = _tmp117_;
	if (_tmp118_ != NULL) {
		ValaExpression* _tmp119_;
		ValaExpression* _tmp120_;
		_tmp119_ = vala_property_get_initializer (self);
		_tmp120_ = _tmp119_;
		vala_code_node_check ((ValaCodeNode*) _tmp120_, context);
	}
	_tmp121_ = vala_code_context_get_analyzer (context);
	_tmp122_ = _tmp121_;
	_tmp123_ = vala_property_get_property_type (self);
	_tmp124_ = _tmp123_;
	if (!vala_semantic_analyzer_is_type_accessible (_tmp122_, (ValaSymbol*) self, _tmp124_)) {
		ValaSourceReference* _tmp125_;
		ValaSourceReference* _tmp126_;
		ValaDataType* _tmp127_;
		ValaDataType* _tmp128_;
		gchar* _tmp129_;
		gchar* _tmp130_;
		gchar* _tmp131_;
		gchar* _tmp132_;
		gchar* _tmp133_;
		gchar* _tmp134_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp125_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp126_ = _tmp125_;
		_tmp127_ = vala_property_get_property_type (self);
		_tmp128_ = _tmp127_;
		_tmp129_ = vala_code_node_to_string ((ValaCodeNode*) _tmp128_);
		_tmp130_ = _tmp129_;
		_tmp131_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp132_ = _tmp131_;
		_tmp133_ = g_strdup_printf ("property type `%s' is less accessible than property `%s'", _tmp130_, _tmp132_);
		_tmp134_ = _tmp133_;
		vala_report_error (_tmp126_, _tmp134_);
		_g_free0 (_tmp134_);
		_g_free0 (_tmp132_);
		_g_free0 (_tmp130_);
	}
	_tmp136_ = self->priv->_overrides;
	if (_tmp136_) {
		ValaProperty* _tmp137_;
		ValaProperty* _tmp138_;
		_tmp137_ = vala_property_get_base_property (self);
		_tmp138_ = _tmp137_;
		_tmp135_ = _tmp138_ == NULL;
	} else {
		_tmp135_ = FALSE;
	}
	if (_tmp135_) {
		ValaSourceReference* _tmp139_;
		ValaSourceReference* _tmp140_;
		gchar* _tmp141_;
		gchar* _tmp142_;
		gchar* _tmp143_;
		gchar* _tmp144_;
		_tmp139_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp140_ = _tmp139_;
		_tmp141_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp142_ = _tmp141_;
		_tmp143_ = g_strdup_printf ("%s: no suitable property found to override", _tmp142_);
		_tmp144_ = _tmp143_;
		vala_report_error (_tmp140_, _tmp144_);
		_g_free0 (_tmp144_);
		_g_free0 (_tmp142_);
	}
	_tmp148_ = vala_symbol_get_external_package ((ValaSymbol*) self);
	_tmp149_ = _tmp148_;
	if (!_tmp149_) {
		gboolean _tmp150_;
		_tmp150_ = self->priv->_overrides;
		_tmp147_ = !_tmp150_;
	} else {
		_tmp147_ = FALSE;
	}
	if (_tmp147_) {
		gboolean _tmp151_;
		gboolean _tmp152_;
		_tmp151_ = vala_symbol_get_hides ((ValaSymbol*) self);
		_tmp152_ = _tmp151_;
		_tmp146_ = !_tmp152_;
	} else {
		_tmp146_ = FALSE;
	}
	if (_tmp146_) {
		ValaSymbol* _tmp153_;
		ValaSymbol* _tmp154_;
		_tmp153_ = vala_symbol_get_hidden_member ((ValaSymbol*) self);
		_tmp154_ = _tmp153_;
		_tmp145_ = _tmp154_ != NULL;
		_vala_code_node_unref0 (_tmp154_);
	} else {
		_tmp145_ = FALSE;
	}
	if (_tmp145_) {
		ValaSourceReference* _tmp155_;
		ValaSourceReference* _tmp156_;
		gchar* _tmp157_;
		gchar* _tmp158_;
		ValaSymbol* _tmp159_;
		ValaSymbol* _tmp160_;
		gchar* _tmp161_;
		gchar* _tmp162_;
		gchar* _tmp163_;
		gchar* _tmp164_;
		_tmp155_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp156_ = _tmp155_;
		_tmp157_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp158_ = _tmp157_;
		_tmp159_ = vala_symbol_get_hidden_member ((ValaSymbol*) self);
		_tmp160_ = _tmp159_;
		_tmp161_ = vala_symbol_get_full_name (_tmp160_);
		_tmp162_ = _tmp161_;
		_tmp163_ = g_strdup_printf ("%s hides inherited property `%s'. Use the `new' keyword if hiding was " \
"intentional", _tmp158_, _tmp162_);
		_tmp164_ = _tmp163_;
		vala_report_warning (_tmp156_, _tmp164_);
		_g_free0 (_tmp164_);
		_g_free0 (_tmp162_);
		_vala_code_node_unref0 (_tmp160_);
		_g_free0 (_tmp158_);
	}
	_tmp166_ = vala_property_get_set_accessor (self);
	_tmp167_ = _tmp166_;
	if (_tmp167_ != NULL) {
		ValaPropertyAccessor* _tmp168_;
		ValaPropertyAccessor* _tmp169_;
		gboolean _tmp170_;
		gboolean _tmp171_;
		_tmp168_ = vala_property_get_set_accessor (self);
		_tmp169_ = _tmp168_;
		_tmp170_ = vala_property_accessor_get_construction (_tmp169_);
		_tmp171_ = _tmp170_;
		_tmp165_ = _tmp171_;
	} else {
		_tmp165_ = FALSE;
	}
	if (_tmp165_) {
		ValaSymbolAccessibility _tmp172_;
		ValaSymbolAccessibility _tmp173_;
		_tmp172_ = vala_symbol_get_access ((ValaSymbol*) self);
		_tmp173_ = _tmp172_;
		if (_tmp173_ != VALA_SYMBOL_ACCESSIBILITY_PUBLIC) {
			ValaSourceReference* _tmp174_;
			ValaSourceReference* _tmp175_;
			gchar* _tmp176_;
			gchar* _tmp177_;
			gchar* _tmp178_;
			gchar* _tmp179_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp174_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp175_ = _tmp174_;
			_tmp176_ = vala_symbol_get_full_name ((ValaSymbol*) self);
			_tmp177_ = _tmp176_;
			_tmp178_ = g_strdup_printf ("%s: construct properties must be public", _tmp177_);
			_tmp179_ = _tmp178_;
			vala_report_error (_tmp175_, _tmp179_);
			_g_free0 (_tmp179_);
			_g_free0 (_tmp177_);
		}
	}
	_tmp183_ = vala_property_get_initializer (self);
	_tmp184_ = _tmp183_;
	if (_tmp184_ != NULL) {
		ValaExpression* _tmp185_;
		ValaExpression* _tmp186_;
		gboolean _tmp187_;
		gboolean _tmp188_;
		_tmp185_ = vala_property_get_initializer (self);
		_tmp186_ = _tmp185_;
		_tmp187_ = vala_code_node_get_error ((ValaCodeNode*) _tmp186_);
		_tmp188_ = _tmp187_;
		_tmp182_ = !_tmp188_;
	} else {
		_tmp182_ = FALSE;
	}
	if (_tmp182_) {
		ValaExpression* _tmp189_;
		ValaExpression* _tmp190_;
		ValaDataType* _tmp191_;
		ValaDataType* _tmp192_;
		_tmp189_ = vala_property_get_initializer (self);
		_tmp190_ = _tmp189_;
		_tmp191_ = vala_expression_get_value_type (_tmp190_);
		_tmp192_ = _tmp191_;
		_tmp181_ = _tmp192_ != NULL;
	} else {
		_tmp181_ = FALSE;
	}
	if (_tmp181_) {
		ValaExpression* _tmp193_;
		ValaExpression* _tmp194_;
		ValaDataType* _tmp195_;
		ValaDataType* _tmp196_;
		ValaDataType* _tmp197_;
		ValaDataType* _tmp198_;
		_tmp193_ = vala_property_get_initializer (self);
		_tmp194_ = _tmp193_;
		_tmp195_ = vala_expression_get_value_type (_tmp194_);
		_tmp196_ = _tmp195_;
		_tmp197_ = vala_property_get_property_type (self);
		_tmp198_ = _tmp197_;
		_tmp180_ = !vala_data_type_compatible (_tmp196_, _tmp198_);
	} else {
		_tmp180_ = FALSE;
	}
	if (_tmp180_) {
		ValaExpression* _tmp199_;
		ValaExpression* _tmp200_;
		ValaSourceReference* _tmp201_;
		ValaSourceReference* _tmp202_;
		ValaDataType* _tmp203_;
		ValaDataType* _tmp204_;
		gchar* _tmp205_;
		gchar* _tmp206_;
		ValaExpression* _tmp207_;
		ValaExpression* _tmp208_;
		ValaDataType* _tmp209_;
		ValaDataType* _tmp210_;
		gchar* _tmp211_;
		gchar* _tmp212_;
		gchar* _tmp213_;
		gchar* _tmp214_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp199_ = vala_property_get_initializer (self);
		_tmp200_ = _tmp199_;
		_tmp201_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp200_);
		_tmp202_ = _tmp201_;
		_tmp203_ = vala_property_get_property_type (self);
		_tmp204_ = _tmp203_;
		_tmp205_ = vala_code_node_to_string ((ValaCodeNode*) _tmp204_);
		_tmp206_ = _tmp205_;
		_tmp207_ = vala_property_get_initializer (self);
		_tmp208_ = _tmp207_;
		_tmp209_ = vala_expression_get_value_type (_tmp208_);
		_tmp210_ = _tmp209_;
		_tmp211_ = vala_code_node_to_string ((ValaCodeNode*) _tmp210_);
		_tmp212_ = _tmp211_;
		_tmp213_ = g_strdup_printf ("Expected initializer of type `%s' but got `%s'", _tmp206_, _tmp212_);
		_tmp214_ = _tmp213_;
		vala_report_error (_tmp202_, _tmp214_);
		_g_free0 (_tmp214_);
		_g_free0 (_tmp212_);
		_g_free0 (_tmp206_);
	}
	_tmp215_ = vala_code_context_get_analyzer (context);
	_tmp216_ = _tmp215_;
	_tmp217_ = old_source_file;
	vala_semantic_analyzer_set_current_source_file (_tmp216_, _tmp217_);
	_tmp218_ = vala_code_context_get_analyzer (context);
	_tmp219_ = _tmp218_;
	_tmp220_ = old_symbol;
	vala_semantic_analyzer_set_current_symbol (_tmp219_, _tmp220_);
	_tmp221_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp222_ = _tmp221_;
	result = !_tmp222_;
	_vala_code_node_unref0 (old_symbol);
	_vala_source_file_unref0 (old_source_file);
	return result;
}


ValaDataType*
vala_property_get_property_type (ValaProperty* self)
{
	ValaDataType* result;
	ValaDataType* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_data_type;
	result = _tmp0_;
	return result;
}


void
vala_property_set_property_type (ValaProperty* self,
                                 ValaDataType* value)
{
	ValaDataType* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_data_type);
	self->priv->_data_type = _tmp0_;
	if (value != NULL) {
		ValaDataType* _tmp1_;
		_tmp1_ = self->priv->_data_type;
		vala_code_node_set_parent_node ((ValaCodeNode*) _tmp1_, (ValaCodeNode*) self);
	}
}


ValaPropertyAccessor*
vala_property_get_get_accessor (ValaProperty* self)
{
	ValaPropertyAccessor* result;
	ValaPropertyAccessor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_get_accessor;
	result = _tmp0_;
	return result;
}


void
vala_property_set_get_accessor (ValaProperty* self,
                                ValaPropertyAccessor* value)
{
	ValaPropertyAccessor* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_get_accessor);
	self->priv->_get_accessor = _tmp0_;
	if (value != NULL) {
		ValaScope* _tmp1_;
		ValaScope* _tmp2_;
		_tmp1_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp2_ = _tmp1_;
		vala_symbol_set_owner ((ValaSymbol*) value, _tmp2_);
	}
}


ValaPropertyAccessor*
vala_property_get_set_accessor (ValaProperty* self)
{
	ValaPropertyAccessor* result;
	ValaPropertyAccessor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_set_accessor;
	result = _tmp0_;
	return result;
}


void
vala_property_set_set_accessor (ValaProperty* self,
                                ValaPropertyAccessor* value)
{
	ValaPropertyAccessor* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_set_accessor);
	self->priv->_set_accessor = _tmp0_;
	if (value != NULL) {
		ValaScope* _tmp1_;
		ValaScope* _tmp2_;
		_tmp1_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp2_ = _tmp1_;
		vala_symbol_set_owner ((ValaSymbol*) value, _tmp2_);
	}
}


ValaParameter*
vala_property_get_this_parameter (ValaProperty* self)
{
	ValaParameter* result;
	ValaParameter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_this_parameter;
	result = _tmp0_;
	return result;
}


void
vala_property_set_this_parameter (ValaProperty* self,
                                  ValaParameter* value)
{
	ValaParameter* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_this_parameter);
	self->priv->_this_parameter = _tmp0_;
}


gboolean
vala_property_get_interface_only (ValaProperty* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_interface_only;
	result = _tmp0_;
	return result;
}


void
vala_property_set_interface_only (ValaProperty* self,
                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_interface_only = value;
}


gboolean
vala_property_get_is_abstract (ValaProperty* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_abstract;
	result = _tmp0_;
	return result;
}


void
vala_property_set_is_abstract (ValaProperty* self,
                               gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_abstract = value;
}


gboolean
vala_property_get_is_virtual (ValaProperty* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_virtual;
	result = _tmp0_;
	return result;
}


void
vala_property_set_is_virtual (ValaProperty* self,
                              gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_virtual = value;
}


gboolean
vala_property_get_overrides (ValaProperty* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_overrides;
	result = _tmp0_;
	return result;
}


void
vala_property_set_overrides (ValaProperty* self,
                             gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_overrides = value;
}


ValaField*
vala_property_get_field (ValaProperty* self)
{
	ValaField* result;
	gboolean _tmp0_;
	ValaField* _tmp61_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_field_checked;
	if (!_tmp0_) {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_;
		_tmp2_ = self->priv->_is_abstract;
		if (!_tmp2_) {
			ValaSourceFileType _tmp3_;
			ValaSourceFileType _tmp4_;
			_tmp3_ = vala_symbol_get_source_type ((ValaSymbol*) self);
			_tmp4_ = _tmp3_;
			_tmp1_ = _tmp4_ == VALA_SOURCE_FILE_TYPE_SOURCE;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			gboolean has_get = FALSE;
			ValaPropertyAccessor* _tmp5_;
			ValaPropertyAccessor* _tmp6_;
			gboolean _tmp7_ = FALSE;
			gboolean _tmp8_;
			gboolean get_has_body = FALSE;
			gboolean has_set = FALSE;
			ValaPropertyAccessor* _tmp13_;
			ValaPropertyAccessor* _tmp14_;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp16_;
			gboolean set_has_body = FALSE;
			gboolean _tmp21_ = FALSE;
			gboolean _tmp22_;
			gboolean _tmp28_ = FALSE;
			gboolean _tmp29_;
			gboolean _tmp35_ = FALSE;
			gboolean _tmp36_;
			_tmp5_ = vala_property_get_get_accessor (self);
			_tmp6_ = _tmp5_;
			has_get = _tmp6_ != NULL;
			_tmp8_ = has_get;
			if (_tmp8_) {
				ValaPropertyAccessor* _tmp9_;
				ValaPropertyAccessor* _tmp10_;
				ValaBlock* _tmp11_;
				ValaBlock* _tmp12_;
				_tmp9_ = vala_property_get_get_accessor (self);
				_tmp10_ = _tmp9_;
				_tmp11_ = vala_subroutine_get_body ((ValaSubroutine*) _tmp10_);
				_tmp12_ = _tmp11_;
				_tmp7_ = _tmp12_ != NULL;
			} else {
				_tmp7_ = FALSE;
			}
			get_has_body = _tmp7_;
			_tmp13_ = vala_property_get_set_accessor (self);
			_tmp14_ = _tmp13_;
			has_set = _tmp14_ != NULL;
			_tmp16_ = has_set;
			if (_tmp16_) {
				ValaPropertyAccessor* _tmp17_;
				ValaPropertyAccessor* _tmp18_;
				ValaBlock* _tmp19_;
				ValaBlock* _tmp20_;
				_tmp17_ = vala_property_get_set_accessor (self);
				_tmp18_ = _tmp17_;
				_tmp19_ = vala_subroutine_get_body ((ValaSubroutine*) _tmp18_);
				_tmp20_ = _tmp19_;
				_tmp15_ = _tmp20_ != NULL;
			} else {
				_tmp15_ = FALSE;
			}
			set_has_body = _tmp15_;
			_tmp22_ = set_has_body;
			if (_tmp22_) {
				gboolean _tmp23_ = FALSE;
				gboolean _tmp24_;
				_tmp24_ = has_get;
				if (_tmp24_) {
					gboolean _tmp25_;
					_tmp25_ = get_has_body;
					_tmp23_ = !_tmp25_;
				} else {
					_tmp23_ = FALSE;
				}
				_tmp21_ = _tmp23_;
			} else {
				_tmp21_ = FALSE;
			}
			if (_tmp21_) {
				ValaSourceReference* _tmp26_;
				ValaSourceReference* _tmp27_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp26_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp27_ = _tmp26_;
				vala_report_error (_tmp27_, "Property getter must have a body");
			}
			_tmp29_ = get_has_body;
			if (_tmp29_) {
				gboolean _tmp30_ = FALSE;
				gboolean _tmp31_;
				_tmp31_ = has_set;
				if (_tmp31_) {
					gboolean _tmp32_;
					_tmp32_ = set_has_body;
					_tmp30_ = !_tmp32_;
				} else {
					_tmp30_ = FALSE;
				}
				_tmp28_ = _tmp30_;
			} else {
				_tmp28_ = FALSE;
			}
			if (_tmp28_) {
				ValaSourceReference* _tmp33_;
				ValaSourceReference* _tmp34_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp33_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp34_ = _tmp33_;
				vala_report_error (_tmp34_, "Property setter must have a body");
			}
			_tmp36_ = get_has_body;
			if (!_tmp36_) {
				gboolean _tmp37_;
				_tmp37_ = set_has_body;
				_tmp35_ = !_tmp37_;
			} else {
				_tmp35_ = FALSE;
			}
			if (_tmp35_) {
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				ValaDataType* _tmp42_;
				ValaDataType* _tmp43_;
				ValaDataType* _tmp44_;
				ValaDataType* _tmp45_;
				ValaExpression* _tmp46_;
				ValaExpression* _tmp47_;
				ValaSourceReference* _tmp48_;
				ValaSourceReference* _tmp49_;
				ValaField* _tmp50_;
				ValaField* _tmp51_;
				ValaField* _tmp52_;
				ValaMemberBinding _tmp53_;
				ValaAttribute* _tmp54_;
				_tmp38_ = vala_symbol_get_name ((ValaSymbol*) self);
				_tmp39_ = _tmp38_;
				_tmp40_ = g_strdup_printf ("_%s", _tmp39_);
				_tmp41_ = _tmp40_;
				_tmp42_ = vala_property_get_property_type (self);
				_tmp43_ = _tmp42_;
				_tmp44_ = vala_data_type_copy (_tmp43_);
				_tmp45_ = _tmp44_;
				_tmp46_ = vala_property_get_initializer (self);
				_tmp47_ = _tmp46_;
				_tmp48_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp49_ = _tmp48_;
				_tmp50_ = vala_field_new (_tmp41_, _tmp45_, _tmp47_, _tmp49_, NULL);
				_vala_code_node_unref0 (self->priv->_field);
				self->priv->_field = _tmp50_;
				_vala_code_node_unref0 (_tmp45_);
				_g_free0 (_tmp41_);
				_tmp51_ = self->priv->_field;
				vala_symbol_set_access ((ValaSymbol*) _tmp51_, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
				_tmp52_ = self->priv->_field;
				_tmp53_ = self->priv->_binding;
				vala_field_set_binding (_tmp52_, _tmp53_);
				_tmp54_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "GtkChild");
				if (_tmp54_ != NULL) {
					ValaField* _tmp55_;
					const gchar* _tmp56_;
					const gchar* _tmp57_;
					gchar* _tmp58_;
					gchar* _tmp59_;
					ValaField* _tmp60_;
					_tmp55_ = self->priv->_field;
					_tmp56_ = vala_symbol_get_name ((ValaSymbol*) self);
					_tmp57_ = _tmp56_;
					_tmp58_ = vala_code_node_get_attribute_string ((ValaCodeNode*) self, "GtkChild", "name", _tmp57_);
					_tmp59_ = _tmp58_;
					vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp55_, "GtkChild", "name", _tmp59_, NULL);
					_g_free0 (_tmp59_);
					_tmp60_ = self->priv->_field;
					vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp60_, "GtkChild", "internal", vala_code_node_get_attribute_bool ((ValaCodeNode*) self, "GtkChild", "internal", FALSE), NULL);
				}
			}
		}
		self->priv->_field_checked = TRUE;
	}
	_tmp61_ = self->priv->_field;
	result = _tmp61_;
	return result;
}


ValaMemberBinding
vala_property_get_binding (ValaProperty* self)
{
	ValaMemberBinding result;
	ValaMemberBinding _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_binding;
	result = _tmp0_;
	return result;
}


void
vala_property_set_binding (ValaProperty* self,
                           ValaMemberBinding value)
{
	g_return_if_fail (self != NULL);
	self->priv->_binding = value;
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch20_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch20_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally20;
	__catch20_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally20:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


const gchar*
vala_property_get_nick (ValaProperty* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_nick;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = vala_code_node_get_attribute_string ((ValaCodeNode*) self, "Description", "nick", NULL);
		_g_free0 (self->priv->_nick);
		self->priv->_nick = _tmp1_;
		_tmp2_ = self->priv->_nick;
		if (_tmp2_ == NULL) {
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			_tmp3_ = vala_symbol_get_name ((ValaSymbol*) self);
			_tmp4_ = _tmp3_;
			_tmp5_ = string_replace (_tmp4_, "_", "-");
			_g_free0 (self->priv->_nick);
			self->priv->_nick = _tmp5_;
		}
	}
	_tmp6_ = self->priv->_nick;
	result = _tmp6_;
	return result;
}


const gchar*
vala_property_get_blurb (ValaProperty* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_blurb;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = vala_code_node_get_attribute_string ((ValaCodeNode*) self, "Description", "blurb", NULL);
		_g_free0 (self->priv->_blurb);
		self->priv->_blurb = _tmp1_;
		_tmp2_ = self->priv->_blurb;
		if (_tmp2_ == NULL) {
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			_tmp3_ = vala_symbol_get_name ((ValaSymbol*) self);
			_tmp4_ = _tmp3_;
			_tmp5_ = string_replace (_tmp4_, "_", "-");
			_g_free0 (self->priv->_blurb);
			self->priv->_blurb = _tmp5_;
		}
	}
	_tmp6_ = self->priv->_blurb;
	result = _tmp6_;
	return result;
}


static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
	dup = g_new0 (gboolean, 1);
	memcpy (dup, self, sizeof (gboolean));
	return dup;
}


static gpointer
__bool_dup0 (gpointer self)
{
	return self ? _bool_dup (self) : NULL;
}


gboolean
vala_property_get_notify (ValaProperty* self)
{
	gboolean result;
	gboolean* _tmp0_;
	gboolean* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_notify;
	if (_tmp0_ == NULL) {
		gboolean _tmp1_;
		gboolean* _tmp2_;
		_tmp1_ = vala_code_node_get_attribute_bool ((ValaCodeNode*) self, "CCode", "notify", TRUE);
		_tmp2_ = __bool_dup0 (&_tmp1_);
		_g_free0 (self->priv->_notify);
		self->priv->_notify = _tmp2_;
	}
	_tmp3_ = self->priv->_notify;
	result = *_tmp3_;
	return result;
}


ValaProperty*
vala_property_get_base_property (ValaProperty* self)
{
	ValaProperty* result;
	ValaProperty* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	vala_property_find_base_properties (self);
	_tmp0_ = self->priv->_base_property;
	result = _tmp0_;
	return result;
}


ValaProperty*
vala_property_get_base_interface_property (ValaProperty* self)
{
	ValaProperty* result;
	ValaProperty* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	vala_property_find_base_properties (self);
	_tmp0_ = self->priv->_base_interface_property;
	result = _tmp0_;
	return result;
}


ValaExpression*
vala_property_get_initializer (ValaProperty* self)
{
	ValaExpression* result;
	ValaExpression* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_initializer;
	result = _tmp0_;
	return result;
}


void
vala_property_set_initializer (ValaProperty* self,
                               ValaExpression* value)
{
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_initializer);
	self->priv->_initializer = _tmp0_;
	_tmp1_ = self->priv->_initializer;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp1_, (ValaCodeNode*) self);
}


static gboolean
vala_property_real_get_lock_used (ValaLockable* base)
{
	gboolean result;
	ValaProperty* self;
	gboolean _tmp0_;
	self = (ValaProperty*) base;
	_tmp0_ = self->priv->_lock_used;
	result = _tmp0_;
	return result;
}


static void
vala_property_real_set_lock_used (ValaLockable* base,
                                  gboolean value)
{
	ValaProperty* self;
	self = (ValaProperty*) base;
	self->priv->_lock_used = value;
}


static void
vala_property_class_init (ValaPropertyClass * klass)
{
	vala_property_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_property_finalize;
	g_type_class_adjust_private_offset (klass, &ValaProperty_private_offset);
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_property_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_property_real_accept_children;
	((ValaCodeNodeClass *) klass)->replace_type = (void (*) (ValaCodeNode *, ValaDataType*, ValaDataType*)) vala_property_real_replace_type;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode *, ValaExpression*, ValaExpression*)) vala_property_real_replace_expression;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode *, ValaCodeContext*)) vala_property_real_check;
}


static void
vala_property_vala_lockable_interface_init (ValaLockableIface * iface)
{
	vala_property_vala_lockable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_lock_used = vala_property_real_get_lock_used;
	iface->set_lock_used = vala_property_real_set_lock_used;
}


static void
vala_property_instance_init (ValaProperty * self)
{
	self->priv = vala_property_get_instance_private (self);
	self->priv->_binding = VALA_MEMBER_BINDING_INSTANCE;
}


static void
vala_property_finalize (ValaCodeNode * obj)
{
	ValaProperty * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_PROPERTY, ValaProperty);
	_vala_code_node_unref0 (self->priv->_this_parameter);
	_vala_code_node_unref0 (self->priv->_initializer);
	_vala_code_node_unref0 (self->priv->_data_type);
	_vala_code_node_unref0 (self->priv->_base_interface_property);
	_vala_code_node_unref0 (self->priv->_get_accessor);
	_vala_code_node_unref0 (self->priv->_set_accessor);
	_g_free0 (self->priv->_nick);
	_g_free0 (self->priv->_blurb);
	_g_free0 (self->priv->_notify);
	_vala_code_node_unref0 (self->priv->_field);
	VALA_CODE_NODE_CLASS (vala_property_parent_class)->finalize (obj);
}


/**
 * Represents a property declaration in the source code.
 */
GType
vala_property_get_type (void)
{
	static volatile gsize vala_property_type_id__volatile = 0;
	if (g_once_init_enter (&vala_property_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaPropertyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_property_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaProperty), 0, (GInstanceInitFunc) vala_property_instance_init, NULL };
		static const GInterfaceInfo vala_lockable_info = { (GInterfaceInitFunc) vala_property_vala_lockable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType vala_property_type_id;
		vala_property_type_id = g_type_register_static (VALA_TYPE_SYMBOL, "ValaProperty", &g_define_type_info, 0);
		g_type_add_interface_static (vala_property_type_id, VALA_TYPE_LOCKABLE, &vala_lockable_info);
		ValaProperty_private_offset = g_type_add_instance_private (vala_property_type_id, sizeof (ValaPropertyPrivate));
		g_once_init_leave (&vala_property_type_id__volatile, vala_property_type_id);
	}
	return vala_property_type_id__volatile;
}



